package attivitacomposte;

import attivitaatomiche.AggiornaStatoCella;
import attivitaatomiche.CreaScacchiera;
import attivitaatomiche.VerificaStatoScacchiera;
import _framework.Executor;
import GUI.AttivitaIO;
import GUI.RecordCoordinate;
import GUI.FinestraPrincipale;
import tris.*;

public class AttivitaPrincipale implements Runnable 
{
	private Scacchiera laScacchiera=null;
	private SimboloCella prossimo=SimboloCella.X;
	private boolean finale=false;
	private SimboloCella vincitore=SimboloCella.VUOTO;
		
	public synchronized void run()
	{
		CreaScacchiera taskCrea=new CreaScacchiera();
		Executor.perform(taskCrea);
		laScacchiera=taskCrea.getScacchiera();
		while(!finale)
		{
			RecordCoordinate c=AttivitaIO.selezionaCella(prossimo);
			AggiornaStatoCella taskCella=new AggiornaStatoCella(laScacchiera,c,prossimo);
			Executor.perform(taskCella);
			VerificaStatoScacchiera checkStato=new VerificaStatoScacchiera(laScacchiera);
			Executor.perform(checkStato);
			finale=checkStato.isConfigurazioneFinale();
			if (finale)
				vincitore=checkStato.getVincitore();
			if (prossimo==SimboloCella.O)
				prossimo=SimboloCella.X;
			else
				prossimo=SimboloCella.O;
		}
		AttivitaIO.notificaRisultato(vincitore);
	}
}
